﻿import matplotlib as mpl
mpl.use('Agg')
import matplotlib.pyplot as plt
import numpy as np
import math

def load_primes():
	with open('primes.txt') as dat:
		global primes
		primes = [int(x) for x in dat.read().split(' ')]
		
def plot_difference(expression, num):
	graph = plt.subplot(111)

	x = np.arange(0, num, 1)
	
	global primes
	y = primes[:num]	# real primes
	y2 = [int(round(eval(expression))) for n in range(1,num+1)] # predicted primes
	y3=[(j-i) for i,j in zip(y,y2)]	# diference

	graph.set_ylabel('p(n)')
	graph.set_xlabel('n')
	graph.set_title(u'stvarni / predviđeni prosti brojevi')

	p1, = graph.plot(x, y, 'r-', lw=2, alpha=0.7)
	p2, = graph.plot(x, y2, 'g-', lw=2, alpha=0.7)
	p3, = graph.plot(x, y3, 'b-', lw=2, alpha=0.7)

	graph.grid(True)
	#graph.grid(color='gray', ls='--', lw=0.5, which='both', alpha=0.5)
	graph.legend([p1, p2, p3], ['stvarno', u'predviđeno', 'razlika'], loc=2)

	#plt.show()
	plt.plot()
	plt.savefig('gentest_difference')
	plt.close()
	
def gp_add(a, b): return a+b
def gp_sub(a, b): return a-b
def gp_mul(a, b): return a*b
def gp_div(a, b): return a/b if b!=0 else 0
def gp_mod(a, b): return a%b if b!=0 else 1
def gp_sqrt(a):   return math.sqrt(abs(a))
def gp_ln(a):   return math.log(a) if a>0 else 0

primes=[]
load_primes()

formula = 'gp_add(gp_add(gp_mod(gp_mod(n, 0.515167028065), gp_div(n, -5)), gp_sub(gp_ln(gp_mod(-8, n)), gp_ln(gp_mul(n, 0.113002933479)))), gp_sqrt(gp_mul(gp_add(gp_sub(0.836381570664, n), gp_ln(0.548779293344)), gp_sub(gp_sub(n, 0.46653520261), gp_mul(n, n)))))'

plot_difference(formula, 1000)