﻿import matplotlib.pyplot as plt
import numpy as np

import random
primes=[]

def load_primes():
	with open('primes.txt') as dat:
		primes = [int(x) for x in dat.read().split(' ')]
	return primes

ax = plt.subplot(111)

xs = np.arange(0, 50, 1)
ys = load_primes()[0:50]
ys2=[(x+20) for x in ys]
ys3=[(j-i) for i,j in zip(ys,ys2)]

ax.set_ylabel('p(n)')
ax.set_xlabel('n')
ax.set_title(u'stvarni / predviđeni prosti brojevi')

p1, = ax.plot(xs, ys, 'r-', lw=2, alpha=0.7)
p2, = ax.plot(xs, ys2, 'g-', lw=2, alpha=0.7)
p3, = ax.plot(xs, ys3, 'b-', lw=2, alpha=0.7)

ax.grid(True)
#ax.grid(color='gray', ls='--', lw=0.5, which='both', alpha=0.5)
ax.legend([p1, p2, p3], ['stvarno', u'predviđeno', 'razlika'], loc=2)

#plt.show()
plt.plot()
plt.savefig('myfig')